#include <bits/stdc++.h>

using namespace std;

int kizar(long long int n)
{

    long long int meddig=sqrt(n), jelenleg=0;

    for(long long int i=1;i<=meddig;i++)
    {
        if(n%i==0 && n/i != i)
        {
            jelenleg=jelenleg^i;
            jelenleg=jelenleg^(n/i);
        }
        else if(n/i == i)
        {
            jelenleg=jelenleg^i;
        }
    }


    return jelenleg;
}




int main()
{

    long long int n, k;
    cin>>n>>k;

    vector<long long int> osztok(k);
    for(long long int i=0;i<k;i++)
    {
        cin>>osztok.at(i);
    }


    for(long long int i=0;i<k;i++)
    {
        cout<<kizar(osztok.at(i))<<" ";
    }


/* ertek=osztoi.at(0);

        for(long int j=1;j<osztoi.size();j++)
        {
             ertek=ertek^osztoi.at(j);

        }
        cout<<ertek<<" ";

        */



    return 0;
}